magnetic_length: &magnetic_length 2.1084536356650028   # Remember to change for each change of turns!!!!!! This is printed by FiQuS
number_of_turns: &n_turns 365
I_initial: &I_initial 450  # initial current in A
Is_initial: &Is_initial  # initial current in A
  - c1: &c1 450
  - c2: &c2 400
  - c3: &c3 350
  - c4: &c4 300
  - c5: &c5 250
  - c6: &c6 200
  - c7: &c7 150
  - c8: &c8 100
  - c9: &c9 50
I_control_LUT: &Is_control_LUT
  - [*c1, *c1, 0]
  - [*c2, *c2, 0]
  - [*c3, *c3, 0]
  - [*c4, *c4, 0]
  - [*c5, *c5, 0]
  - [*c6, *c6, 0]
  - [*c7, *c7, 0]
  - [*c8, *c8, 0]
  - [*c9, *c9, 0]
s1: &s1 0.374596 # s1p6r225t200x01
sim3D_Tpulse_sPosition: &sim3D_Tpulse_sPosition [*s1, *s1, *s1, *s1, *s1, *s1, *s1, *s1, *s1] # as many as current levels
3650_sim_num_curr: &3650_sim_num_curr
  - 366001
  - 367001
  - 368001
  - 369001
  - 370001
  - 371001
  - 372001
  - 373001
  - 374001
3651_sim_num_curr: &3651_sim_num_curr
  - 366101
  - 367101
  - 368101
  - 369101
  - 370101
  - 371101
  - 372101
  - 373101
  - 374101
3652_sim_num_curr: &3652_sim_num_curr
  - 366201
  - 367201
  - 368201
  - 369201
  - 370201
  - 371201
  - 372201
  - 373201
  - 374201
3654_sim_num_curr: &3654_sim_num_curr
  - 266401
  - 367401
  - 368401
  - 369401
  - 370401
  - 371401
  - 372401
  - 373401
  - 374401
sim3D_Tpulse_sPositions: &sim3D_Tpulse_sPositions
  - 0.374596 # s1p6r225t365x01
  - 0.489896 # s1p6r315t365x02
  - 1686.923519 # s1p8r225t365x03
  - 1687.041255 # s1p8r315t365x04
  - 3399.541261 # s1p10r225t365x05
  - 3399.661462 # s1p10r315t365x06
  - 1459.592767 # s1p12r225t365x07
  - 1459.727399 # s1p12r315t365x08
  - 3168.939296 # s1p14r225t365x09
  - 3169.076377 # s1p14r315t365x10
  - 194.683488 # s1p16r225t365x11
  - 194.817442 # s1p16r315t365x12
  - 1884.476559 # s1p18r225t365x13
  - 1884.612952 # s1p18r315t365x14
  - 3600.391807 # s1p20r225t365x15
  - 3600.530664 # s1p20r315t365x16
  - 48.271013 # s91p6r225t365x17
  - 48.386313 # s91p6r315t365x18
  - 1735.619861 # s91p8r225t365x19
  - 1735.737597 # s91p8r315t365x20
  - 3449.050688 # s91p10r225t365x21
  - 3449.170889 # s91p10r315t365x22
  - 1515.661668 # s91p12r225t365x23
  - 1515.7963 # s91p12r315t365x24
  - 3225.814784 # s91p14r225t365x25
  - 3225.951866 # s91p14r315t365x26
  - 250.353406 # s91p16r225t365x27
  - 250.48736 # s91p16r315t365x28
  - 1940.947335 # s91p18r225t365x29
  - 1941.083728 # s91p18r315t365x30
  - 3657.674789 # s91p20r225t365x31
  - 3657.813646 # s91p20r315t365x32
  - 96.699612 # s182p6r225t365x33
  - 96.814912 # s182p6r315t365x34
  - 1784.857274 # s182p8r225t365x35
  - 1784.975009 # s182p8r315t365x36
  - 3499.110221 # s182p10r225t365x37
  - 3499.230422 # s182p10r315t365x38
  - 1572.353557 # s182p12r225t365x39
  - 1572.488189 # s182p12r315t365x40
  - 3283.322223 # s182p14r225t365x41
  - 3283.459304 # s182p14r315t365x42
  - 306.641879 # s182p16r225t365x43
  - 306.775833 # s182p16r315t365x44
  - 1998.045564 # s182p18r225t365x45
  - 1998.181958 # s182p18r315t365x46
  - 3715.59425 # s182p20r225t365x47
  - 3715.733107 # s182p20r315t365x48
3650_sim_num: &3650_sim_num
  - 365001
  - 365002
  - 365003
  - 365004
  - 365005
  - 365006
  - 365007
  - 365008
  - 365009
  - 365010
  - 365011
  - 365012
  - 365013
  - 365014
  - 365015
  - 365016
  - 365017
  - 365018
  - 365019
  - 365020
  - 365021
  - 365022
  - 365023
  - 365024
  - 365025
  - 365026
  - 365027
  - 365028
  - 365029
  - 365030
  - 365031
  - 365032
  - 365033
  - 365034
  - 365035
  - 365036
  - 365037
  - 365038
  - 365039
  - 365040
  - 365041
  - 365042
  - 365043
  - 365044
  - 365045
  - 365046
  - 365047
  - 365048
3651_sim_num: &3651_sim_num
  - 365101
  - 365102
  - 365103
  - 365104
  - 365105
  - 365106
  - 365107
  - 365108
  - 365109
  - 365110
  - 365111
  - 365112
  - 365113
  - 365114
  - 365115
  - 365116
  - 365117
  - 365118
  - 365119
  - 365120
  - 365121
  - 365122
  - 365123
  - 365124
  - 365125
  - 365126
  - 365127
  - 365128
  - 365129
  - 365130
  - 365131
  - 365132
  - 365133
  - 365134
  - 365135
  - 365136
  - 365137
  - 365138
  - 365139
  - 365140
  - 365141
  - 365142
  - 365143
  - 365144
  - 365145
  - 365146
  - 365147
  - 365148
3652_sim_num: &3652_sim_num
  - 365201
  - 365202
  - 365203
  - 365204
  - 365205
  - 365206
  - 365207
  - 365208
  - 365209
  - 365210
  - 365211
  - 365212
  - 365213
  - 365214
  - 365215
  - 365216
  - 365217
  - 365218
  - 365219
  - 365220
  - 365221
  - 365222
  - 365223
  - 365224
  - 365225
  - 365226
  - 365227
  - 365228
  - 365229
  - 365230
  - 365231
  - 365232
  - 365233
  - 365234
  - 365235
  - 365236
  - 365237
  - 365238
  - 365239
  - 365240
  - 365241
  - 365242
  - 365243
  - 365244
  - 365245
  - 365246
  - 365247
  - 365248
3654_sim_num: &3654_sim_num
  - 365401
  - 365402
  - 365403
  - 365404
  - 365405
  - 365406
  - 365407
  - 365408
  - 365409
  - 365410
  - 365411
  - 365412
  - 365413
  - 365414
  - 365415
  - 365416
  - 365417
  - 365418
  - 365419
  - 365420
  - 365421
  - 365422
  - 365423
  - 365424
  - 365425
  - 365426
  - 365427
  - 365428
  - 365429
  - 365430
  - 365431
  - 365432
  - 365433
  - 365434
  - 365435
  - 365436
  - 365437
  - 365438
  - 365439
  - 365440
  - 365441
  - 365442
  - 365443
  - 365444
  - 365445
  - 365446
  - 365447
  - 365448
GeneralParameters:
  analysis_name: MCBRD_FQPLs                                             # this is complete consecutive simulation setup for FQPLs paper for ASC 2022    £ analysis_name, model/name, simulation_name -> why so many names?
  flag_permanent_settings: True                                                    # False means use settings from the steam_sdk settings.user_name.yaml
  model:
    name: MCBRD_FQPLs                                                      # should this match analysis name?
    version: 0.1                                                                   # up to a user to choose granularity and number of dots
    case: analysis for publication                                                 # this is to indicate what use case has this file or what circuit protection type or failure case is considered
    state: work in progress                                                        # what state is this file in, work in progress or final and released
PermanentSettings:                                                                 # these will be not used if flag_permanent_settings is set to False, instead a local settings.user_name.yaml file created in the folder of this yaml is used.
  comsolexe_path: null
  JAVA_jdk_path: null
  CFunLibPath: null
  COSIM_path: null
  Dakota_path: null
  FiQuS_path: E:\Python\steam-fiqus-dev                     # used version with commit hash: c2b661c2929c8d8252166da3c2ef6ecfa87ba90a
  LEDET_path: E:\LEDET\LEDET_v2_02_16\LEDET_v2_02_16.exe    # use this specific LEDET executable
  ProteCCT_path: null
  PSPICE_path: null
  PyBBQ_path: null
  XYCE_path: null
  PSPICE_library_path: null
  local_Dakota_path: null
  local_FiQuS_folder: D:\FQPC_FiQuS_folder\                                     # path to local FiQuS folder, this means FiQuS puts its files in here
  local_LEDET_folder: D:\FQPC_LEDET_folder\LEDET                                   # path to LEDET folder inside local LEDET folder, this means LEDET model files (but not the field maps) are put here
  local_PyBBQ_folder: null
  local_PSPICE_folder: null
  local_XYCE_folder: null
WorkingFolders:
  library_path: ../../../steam_models                                               # source for default model data comes from this path
  output_path: output                                                               # name of the folder to be created. This is done in the folder where this analysis.yaml is
  temp_path: temp                                                                   # not sure what this one does                   £ what is this path used for?
AnalysisStepDefinition:
  setup_folders_LEDET:                                                               # name of the step defined by the user
    type: SetUpFolder                                                               # specific action name, in this case setting up folder for the software listed in software
    simulation_name: MCBRD                                                          # name for simulation folder. This is not necessarily a 'top-level' folder name. Folder is created in path specified in local_SOFTWARE_folder   £ why simulation number is not used to make folder with _simulation_number?
    software: [LEDET]                                                               # list of software names for which a folder needs to be set up. Only LEDET needs this as FiQus manages its own folders.
  load_model_data_from_library:
    type: MakeModel                                                                 # step MakeModel does not make model. In this case it is more like 'LoadModel'   £ is it only me that finds this name confusing?
    model_name: MCBRD_ref                                                           # Load model_data from reference file and use name MCBRD_ref for it
    file_model_data: MCBRD                      #  For FiSuS 3650, 3652 and 3654 use: MCBRD, for FiQuS 3651 use MCBRD_FQPC, For LEDET always use MCBRD_FQPC                              # Folder name and part of file name i.e.: modelData_file_model_data.yaml in steam-model library for case_model
    case_model: magnet                                                              # Which folder the model_data is taken from, in this case magnet means magnets folder    £ why magnet for magnets folder, would it be 'nicer' if these match?
    software: [FiQuS]                                                               # Software names list to define which builders to use at this stage if simulation_number is not null, or at a later stage if simulation number is null    £ Option of setting [FiQuS, LEDET] would not work as ledet builder is looking at this stage for a file made by FiQuS
    flag_yaml: False                                                                # This is used in AnalysisSTEAM.py, however is missing in DataAnlaysis.py, it is also valid for LEDET and is hardcoded to True for LEDET. However, LEDET uses xlsx anyhow, even if .yaml is present!   £ this needs clean up!!
    flag_json: False                                                                # This is only applicable to LEDET. £ It is confusing to have it for other tools! Coding it to default to False and not need to specify it added.
  modify_FiQuS_for_all:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
    - CoilWindings.CCT_straight.winding_numberTurnsFormers
    - Options_FiQuS.run.overwrite
    - Options_FiQuS.run.type
    - Options_FiQuS.run.geometry
    - Options_FiQuS.run.mesh
    - Options_FiQuS.run.solution
    - Options_FiQuS.cct.geometry.formers.names
    - Options_FiQuS.cct.geometry.formers.z_mins
    - Options_FiQuS.cct.solve.formers.sigmas
    - Options_FiQuS.cct.solve.formers.mu_rs
    - Options_FiQuS.cct.geometry.formers.z_maxs
    - CoilWindings.CCT_straight.former_inner_radiuses
    - CoilWindings.CCT_straight.former_outer_radiuses
    - Quench_Protection.FQPLs.z_ends
    - Options_FiQuS.cct.geometry.air.z_min
    - Options_FiQuS.cct.geometry.air.z_max
    variables_value:
    - [[*n_turns, *n_turns]]
    - [true]
    - ['start_from_yaml']  # run types for fiqus are: start_from_yaml | geometry_only | mesh_only | mesh_and_solve_with_post_process_python | solve_with_pp | solve_only | post_process_getdp_only | post_process_python_only
    - [1]
    - [1]
    - [1]
    - [[]]
    - [[]]
    - [[]]
    - [[]]
    - [[]]
    - [[]]
    - [[]]
    - [[1.08, 1.08, 1.08, 1.08]]
    - [-2.0]
    - [2.0]
    software: [FiQuS]
  make_modify_FiQuS_3650:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    simulation_name: MCBRD #MCBRD_365a0_365a0_0i
    simulation_numbers: [3650]
    software: [FiQuS]
    variables_to_change:
    - GeneralParameters.magnet_name  # simulation name used in FiQuS
    - Quench_Protection.FQPLs.enabled
    variables_value:
    - [MCBRD_365a0_365a0_0i]      # £ despite looking like this is done for FiQuS only, the change of magnet name affects LEDET too, confusing?
    - [[false, false, false, false]]  # keeping 4 FQPLs
  run_sim_FiQuS_3650:
    type: RunSimulation
    simulation_name: MCBRD # MCBRD_365a0_365a0_0i
    software: FiQuS
    simulation_numbers: [3650]
  make_modify_FiQuS_3651:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    simulation_name: MCBRD #MCBRD_365a0_365a0_0i
    simulation_numbers: [3651]
    software: [FiQuS]
    variables_to_change:
    - GeneralParameters.magnet_name  # simulation name used in FiQuS
    - Quench_Protection.FQPLs.enabled
    variables_value:
    - [MCBRD_365n1_365n1_0i]      # £ despite looking like this is done for FiQuS only, the change of magnet name affects LEDET too, confusing?
    - [[true, false, true, false]]  # keeping 4 FQPLs
  run_sim_FiQuS_3651:
    type: RunSimulation
    simulation_name: MCBRD # MCBRD_365a0_365a0_0i
    software: FiQuS
    simulation_numbers: [3651]
  make_modify_FiQuS_3652:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    simulation_name: MCBRD
    simulation_numbers: [3652] #MCBRD_200a1_200a1_0i
    software: [FiQuS]
    variables_to_change:
      - GeneralParameters.magnet_name  # simulation name used in FiQuS
      - Quench_Protection.FQPLs.enabled
    variables_value:
      - [MCBRD_365a1_365a1_0i]      # £ despite looking like this is done for FiQuS only, the change of magnet name affects LEDET too, confusing?
      - [[true, false, true, false]]  # changing from 4 to 2 FQPLs, so need to adjust all properties
  run_sim_FiQuS_3652:
    type: RunSimulation
    simulation_name: MCBRD # MCBRD_200a1_200a1_0i
    software: FiQuS
    simulation_numbers: [3652]
  make_modify_FiQuS_3654:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    simulation_name: MCBRD
    simulation_numbers: [3654] #MCBRD_200a2_200a2_0i
    software: [FiQuS]
    variables_to_change:
      - GeneralParameters.magnet_name  # simulation name used in FiQuS
      - Quench_Protection.FQPLs.enabled
    variables_value:
      - [MCBRD_365a2_365a2_0i]      # £ despite looking like this is done for FiQuS only, the change of magnet name affects LEDET too, confusing?
      - [[true, true, true, true]]  # changing from 4 to 0 FQPLs, so need to adjust all properties
  run_sim_FiQuS_3654:
    type: RunSimulation
    simulation_name: MCBRD # MCBRD_200a2_200a2_0i
    software: FiQuS
    simulation_numbers: [3654]
  modify_LEDET_name:
    type: ModifyModel
    model_name: MCBRD_ref
    variable_to_change: GeneralParameters.magnet_name
    variable_value: ['MCBRD']      # ledet needs to have matching magnet name and simulation names, otherwise it does not work
    simulation_name: MCBRD
    simulation_numbers: []
    software: [LEDET]
  modify_LEDET_all:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Power_Supply.t_off
      - Power_Supply.t_control_LUT
      - Power_Supply.I_control_LUT
      - Power_Supply.I_initial
      - Quench_Protection.Energy_Extraction.t_trigger
      - Options_LEDET.time_vector.time_vector_params
      - GeneralParameters.magnetic_length
    variables_value:
      - [99999]   # keep PC util it trips at 10V
      - [[-0.07, 1.495, 1.5]] # do not switch PC off until the end
      - [[*I_initial, *I_initial, 0]]
      - [*I_initial]
      - [99999]
      - [[-0.07, 0.0005, 0.05, 0.052, 0.002, 0.5, 0.505, 0.005, 0.8]]
      - [*magnetic_length]
    software: [LEDET]
  copy_3D_FiQuS_to_steam_models_3650: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3650\Geometry_1\Mesh_1\Solution_1\field_map_3D.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3650.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_3D_steam_models_to_LEDET_3650: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: E:\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3650.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\MCBRD_3650.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_M_FiQuS_to_steam_models_3650:
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3650\Geometry_1\Mesh_1\Solution_1\selfMutualInductanceMatrix.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3650.csv
  copy_M_steam_models_to_LEDET_3650:
    type: CopyFile
    full_path_file_to_copy: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3650.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\\MCBRD_selfMutualInductanceMatrix_3650.csv
  modify_LEDET_3650:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.input_generation_options.selfMutualInductanceFileNumber
      - Options_LEDET.simulation_3D.sim3D_import3DGeometry_modelNumber
    variables_value:
      - [3650]
      - [3650]
    software: [LEDET]
  make_modify_LEDET_positions_3650:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
    variables_value:
      - *sim3D_Tpulse_sPositions
    simulation_name: MCBRD
    simulation_numbers: *3650_sim_num   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_positions_3650:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3650_sim_num
  make_modify_LEDET_currents_3650:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
      - Power_Supply.I_initial
      - Power_Supply.I_control_LUT
    variables_value:
      - *sim3D_Tpulse_sPosition
      - *Is_initial
      - *Is_control_LUT
    simulation_name: MCBRD
    simulation_numbers: *3650_sim_num_curr   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_currents_3650:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3650_sim_num_curr
  copy_3D_FiQuS_to_steam_models_3651: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3651\Geometry_1\Mesh_1\Solution_1\field_map_3D.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3651.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_3D_steam_models_to_LEDET_3651: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: E:\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3651.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\MCBRD_3651.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_M_FiQuS_to_steam_models_3651:
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3651\Geometry_1\Mesh_1\Solution_1\selfMutualInductanceMatrix.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3651.csv
  copy_M_steam_models_to_LEDET_3651:
    type: CopyFile
    full_path_file_to_copy: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3651.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\\MCBRD_selfMutualInductanceMatrix_3651.csv
  modify_LEDET_3651:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.input_generation_options.selfMutualInductanceFileNumber
      - Options_LEDET.simulation_3D.sim3D_import3DGeometry_modelNumber
      - Quench_Protection.FQPLs.th_conns_def  # to change thermal connection and connect the FQPL only on top of the channel
    variables_value:
      - [3651]
      - [3651]
      - [[[[[[false, false], [true, true]], [[false, false], [false, false]]], [[[false, false], [true, true]], [[false, false], [false, false]]]],[[[[false, false], [true, true]], [[false, false], [false, false]]], [[[false, false], [true, true]], [[false, false], [false, false]]]],[[[[false, false], [false, false]], [[false, false], [true, true]]], [[[false, false], [false, false]], [[false, false], [true, true]]]],[[[[false, false], [false, false]], [[false, false], [true, true]]], [[[false, false], [false, false]], [[false, false], [true, true]]]]]]
    software: [LEDET]
  make_modify_LEDET_positions_3651:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
    variables_value:
      - *sim3D_Tpulse_sPositions
    simulation_name: MCBRD
    simulation_numbers: *3651_sim_num   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_positions_3651:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3651_sim_num
  make_modify_LEDET_currents_3651:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
      - Power_Supply.I_initial
      - Power_Supply.I_control_LUT
    variables_value:
      - *sim3D_Tpulse_sPosition
      - *Is_initial
      - *Is_control_LUT
    simulation_name: MCBRD
    simulation_numbers: *3651_sim_num_curr   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_currents_3651:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3651_sim_num_curr
  copy_3D_FiQuS_to_steam_models_3652: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3652\Geometry_1\Mesh_1\Solution_1\field_map_3D.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3652.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_3D_steam_models_to_LEDET_3652: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: E:\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3652.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\MCBRD_3652.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_M_FiQuS_to_steam_models_3652:
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3652\Geometry_1\Mesh_1\Solution_1\selfMutualInductanceMatrix.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3652.csv
  copy_M_steam_models_to_LEDET_3652:
    type: CopyFile
    full_path_file_to_copy: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3652.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\\MCBRD_selfMutualInductanceMatrix_3652.csv
  modify_LEDET_3652:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.input_generation_options.selfMutualInductanceFileNumber
      - Options_LEDET.simulation_3D.sim3D_import3DGeometry_modelNumber
      - Quench_Protection.FQPLs.th_conns_def  # change it back to the original both top and bottom of channel with go and return of FQPCs
    variables_value:
      - [3652]
      - [3652]
      - [[[[[[true, false], [false, false]], [[false, false], [false, false]]], [[[false, false], [true, false]], [[false, false], [false, false]]]],[[[[true, false], [false, false]], [[false, false], [false, false]]], [[[false, false], [true, false]], [[false, false], [false, false]]]],[[[[false, false], [false, false]], [[true, false], [false, false]]], [[[false, false], [false, false]], [[false, false], [true, false]]]],[[[[false, false], [false, false]], [[true, false], [false, false]]], [[[false, false], [false, false]], [[false, false], [true, false]]]]]]
    software: [LEDET]
  make_modify_LEDET_positions_3652:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
    variables_value:
      - *sim3D_Tpulse_sPositions
    simulation_name: MCBRD
    simulation_numbers: *3652_sim_num   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  make_modify_LEDET_currents_3652:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
      - Power_Supply.I_initial
      - Power_Supply.I_control_LUT
    variables_value:
      - *sim3D_Tpulse_sPosition
      - *Is_initial
      - *Is_control_LUT
    simulation_name: MCBRD
    simulation_numbers: *3652_sim_num_curr   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_currents_3652:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3652_sim_num_curr
  run_sim_LEDET_positions_3652:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3652_sim_num
  copy_3D_FiQuS_to_steam_models_3654: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3654\Geometry_1\Mesh_1\Solution_1\field_map_3D.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3654.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_3D_steam_models_to_LEDET_3654: # this is needed for the current setup, i.e. the 3d field map is expected in the steam models as it is an input for LEDET. From FiQuS perspective, FiQuS is ending up with its output in the same folder as its input.
    type: CopyFile
    full_path_file_to_copy: E:\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_3654.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\MCBRD_3654.csv       # this needs to be there, but it does not get copied by analysis so next step does it
  copy_M_FiQuS_to_steam_models_3654:
    type: CopyFile
    full_path_file_to_copy: D:\FQPC_FiQuS_folder\MCBRD_3654\Geometry_1\Mesh_1\Solution_1\selfMutualInductanceMatrix.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3654.csv
  copy_M_steam_models_to_LEDET_3654:
    type: CopyFile
    full_path_file_to_copy: E:\\Python\steam_models\magnets\MCBRD_FQPC\input\MCBRD_selfMutualInductanceMatrix_3654.csv                          # £ this needs addressing as it is no good to specify full paths, how to use local_software_folder
    full_path_file_target: D:\FQPC_LEDET_folder\LEDET\MCBRD\Input\\MCBRD_selfMutualInductanceMatrix_3654.csv
  modify_LEDET_3654:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.input_generation_options.selfMutualInductanceFileNumber
      - Options_LEDET.simulation_3D.sim3D_import3DGeometry_modelNumber
      - Quench_Protection.FQPLs.th_conns_def  # change it back to the original both top and bottom of channel with go and return of FQPCs
    variables_value:
      - [3654]
      - [3654]
      - [[[[[[true, false], [false, false]], [[false, false], [false, false]]], [[[false, false], [true, false]], [[false, false], [false, false]]]],[[[[true, false], [false, false]], [[false, false], [false, false]]], [[[false, false], [true, false]], [[false, false], [false, false]]]],[[[[false, false], [false, false]], [[true, false], [false, false]]], [[[false, false], [false, false]], [[false, false], [true, false]]]],[[[[false, false], [false, false]], [[true, false], [false, false]]], [[[false, false], [false, false]], [[false, false], [true, false]]]]]]
    software: [LEDET]
  make_modify_LEDET_positions_3654:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
    variables_value:
      - *sim3D_Tpulse_sPositions
    simulation_name: MCBRD
    simulation_numbers: *3654_sim_num   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_positions_3654:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3654_sim_num
  make_modify_LEDET_currents_3654:
    type: ModifyModelMultipleVariables
    model_name: MCBRD_ref
    variables_to_change:
      - Options_LEDET.simulation_3D.sim3D_Tpulse_sPosition
      - Power_Supply.I_initial
      - Power_Supply.I_control_LUT
    variables_value:
      - *sim3D_Tpulse_sPosition
      - *Is_initial
      - *Is_control_LUT
    simulation_name: MCBRD
    simulation_numbers: *3654_sim_num_curr   # before being able to AddAuxiliaryFile and RunSimulation a make_modify step needs to be called.
    software: [LEDET]
  run_sim_LEDET_currents_3654:
    type: RunSimulation
    simulation_name: MCBRD
    software: LEDET
    simulation_numbers: *3654_sim_num_curr
AnalysisStepSequence:
# **** All (FiQuS and LEDET)
  - setup_folders_LEDET                         # this step is only needed for LEDET in this file. FiQuS manages its folders without this step.
  - load_model_data_from_library
# *** FiQuS All (3650, 3652, 3654)
  - modify_FiQuS_for_all
# *** LEDET All ----
  - modify_LEDET_all
# ******************* 3650 ******************
# ** FiQuS 3650
#  - make_modify_FiQuS_3650   # do not disable for LEDET 3650
#  - run_sim_FiQuS_3650
# ** LEDET 3650
  - modify_LEDET_name
  - copy_3D_FiQuS_to_steam_models_3650
  - copy_3D_steam_models_to_LEDET_3650
  - copy_M_FiQuS_to_steam_models_3650
  - copy_M_steam_models_to_LEDET_3650
  - modify_LEDET_3650
  - make_modify_LEDET_positions_3650
  - run_sim_LEDET_positions_3650
#  - make_modify_LEDET_currents_3650
#  - run_sim_LEDET_currents_3650
## ******************* 3651 ******************
## ** FiQuS 3651
#  - make_modify_FiQuS_3651   # do not disable for LEDET 3651
#  - run_sim_FiQuS_3651
## ** LEDET 3651
#  - modify_LEDET_name
#  - copy_3D_FiQuS_to_steam_models_3651
#  - copy_3D_steam_models_to_LEDET_3651
#  - copy_M_FiQuS_to_steam_models_3651
#  - copy_M_steam_models_to_LEDET_3651
#  - modify_LEDET_3651
#  - make_modify_LEDET_positions_3651
#  - run_sim_LEDET_positions_3651
#  - make_modify_LEDET_currents_3651
#  - run_sim_LEDET_currents_3651
## ******************* 3652 ******************
## ** FiQuS 3652
#  - make_modify_FiQuS_3652   # do not disable for LEDET 3652
#  - run_sim_FiQuS_3652
## ** LEDET 3652
#  - modify_LEDET_name
#  - copy_3D_FiQuS_to_steam_models_3652
#  - copy_3D_steam_models_to_LEDET_3652
#  - copy_M_FiQuS_to_steam_models_3652
#  - copy_M_steam_models_to_LEDET_3652
#  - modify_LEDET_3652
#  - make_modify_LEDET_positions_3652
#  - run_sim_LEDET_positions_3652
#  - make_modify_LEDET_currents_3652
#  - run_sim_LEDET_currents_3652
## ******************* 3654 ******************
## ** FiQuS 3654
#  - make_modify_FiQuS_3654   # do not disable for LEDET 3654
#  - run_sim_FiQuS_3654
## ** LEDET 3654
#  - modify_LEDET_name
#  - copy_3D_FiQuS_to_steam_models_3654
#  - copy_3D_steam_models_to_LEDET_3654
#  - copy_M_FiQuS_to_steam_models_3654
#  - copy_M_steam_models_to_LEDET_3654
#  - modify_LEDET_3654
#  - make_modify_LEDET_positions_3654
#  - run_sim_LEDET_positions_3654
#  - make_modify_LEDET_currents_3654
#  - run_sim_LEDET_currents_3654